routes/web.php
<?php

use App\Http\Controllers\AuthorController;
use App\Http\Controllers\BookController;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/weather', [Controller::class, 'weather'])->name('weather');

Route::group(['middleware' => 'auth'], function () {
    Route::get('/', [Controller::class, 'home'])->name('home');

    Route::group(['prefix' => '/books', 'as' => 'book.'], function () {
        Route::get('/', [BookController::class, 'index'])->name('index');
        Route::get('/create', [BookController::class, 'create'])->name('create');
        Route::get('/{id}', [BookController::class, 'show'])->name('show');
        Route::get('/{id}/edit', [BookController::class, 'edit'])->name('edit');
        Route::get('/{id}/delete', [BookController::class, 'delete'])->name('delete');

        Route::post('/', [BookController::class, 'store'])->name('store');
        Route::post('/{id}/update', [BookController::class, 'update'])->name('update');
        Route::post('/{id}/delete', [BookController::class, 'destroy'])->name('destroy');
    });

    Route::group(['prefix' => '/authors', 'as' => 'author.'], function () {
        Route::get('/', [AuthorController::class, 'index'])->name('index');
        Route::get('/create', [AuthorController::class, 'create'])->name('create');
        Route::get('/{id}', [AuthorController::class, 'show'])->name('show');
        Route::get('/{id}/edit', [AuthorController::class, 'edit'])->name('edit');
        Route::get('/{id}/delete', [AuthorController::class, 'delete'])->name('delete');

        Route::post('/', [AuthorController::class, 'store'])->name('store');
        Route::post('/{id}/update', [AuthorController::class, 'update'])->name('update');
        Route::post('/{id}/delete', [AuthorController::class, 'destroy'])->name('destroy');
    });

});

require __DIR__ . '/auth.php';

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.app');
    }
}

resources/views/500.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0,maximum-scale=1">

    <title>HS Assigment</title>

    <!-- Loading third party fonts -->
    <link href="http://fonts.googleapis.com/css?family=Roboto:300,400,700|" rel="stylesheet" type="text/css">
    <link href="fonts/font-awesome.min.css" rel="stylesheet" type="text/css">

    <!-- Loading main css file -->
    <link rel="stylesheet" href="style.css">

    <!--[if lt IE 9]>
    <script src="js/ie-support/html5.js"></script>
    <script src="js/ie-support/respond.js"></script>
    <![endif]-->

</head>

<body>

<div class="site-content">
    <div class="site-header">
        <div class="container">
            <a href="index.html" class="branding">
                <img src="images/logo.png" alt="" class="logo">
                <div class="logo-type">
                    <h1 class="site-title">60 min Project</h1></div>
            </a>

            <!-- Default snippet for navigation -->
            <div class="main-navigation">
                <button type="button" class="menu-toggle"><i class="fa fa-bars"></i></button>
                <ul class="menu">

                </ul> <!-- .menu -->
            </div> <!-- .main-navigation -->

            <div class="mobile-navigation"></div>

        </div>
    </div> <!-- .site-header -->

    <div class="hero" data-bg-image="images/banner.png">
        <div class="container">
            <form action="weather" class="find-location">
                @csrf()
                <input name="q" type="text" placeholder="Find your location..." value="{{old('q', $q ?? "Spain")}}">
                <input type="submit" value="Find">
            </form>

        </div>
    </div>
    <div class="forecast-table">
        <div class="container">
            <div class="forecast-container">
                <p class="num" style='padding: 120px 20px; color: #bfc1c8; font-family: "Roboto", "Open Sans", sans-serif;  font-size: 25px; font-weight: 300; line-height: 1.5; background: #1e202b;' >
                    OPPS! - Something went wrong, check your search query and try again.
                </p>
            </div>
        </div>
    </div>

    <footer class="site-footer">
        <div class="container">
            <div class="row">
                <div class="col-md-8">
                    <form action="#" method="post" class="subscribe-form">
                        <input type="text" placeholder="" style="visibility: hidden">
                    </form>
                </div>
                <div class="col-md-3 col-md-offset-1">
                </div>
            </div>

            <p class="colophon">Copyright 2021 Harbour.Space. Designed by Adel in 60 min, All rights reserved</p>
        </div>
    </footer> <!-- .site-footer -->
</div>

<script src="js/jquery-1.11.1.min.js"></script>
<script src="js/plugins.js"></script>
<script src="js/app.js"></script>

</body>

</html>

resources/views/home.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Home') }}
        </h2>
    </x-slot>

    <div class="container-fluid">
        <div class="py-12">
            <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
                <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                    <a href="{{route('weather')}}">
                        <div class="p-6 bg-white border-b border-gray-200">
                            {{__('Weather')}}
                        </div>
                    </a>

                    <a href="{{route('book.index')}}">
                        <div class="p-6 bg-white border-b border-gray-200">
                            {{__('Books')}}
                        </div>
                    </a>

                    <a href="{{route('author.index')}}">
                        <div class="p-6 bg-white border-b border-gray-200">
                            {{__('Authors')}}
                        </div>
                    </a>

                </div>

                <div class="justify-content-center d-flex mt-5">
                    <h1 class="text-center " style="font-size: 36px; font-weight: bold">Donate to the Library</h1>
                    <p style="font-size: 20px;">Libraries are much more than buildings full of books; they are community gathering places that serve as learning centers for all educational levels,
                        professional development,
                        culture, creativity and fun. Support from the community is vital to the success of the Library and there are several ways to give that will help in the purchase of books,
                        magazines, electronic resources and new technology. Financial donations also support the many programs the Library offers throughout the year.</p>
                    <div class="d-flex justify-content-center w-100 text-center mt-5">
                        <div id="donate-button-container">
                            <div id="donate-button"></div>
                            <script src="https://www.paypalobjects.com/donate/sdk/donate-sdk.js" charset="UTF-8"></script>
                            <script>
                                PayPal.Donation.Button({
                                    env: 'production',
                                    hosted_button_id: 'VR8TEL53N8DS6',
                                    image: {
                                        src: 'https://www.paypalobjects.com/en_US/ES/i/btn/btn_donateCC_LG.gif',
                                        alt: 'Donate with PayPal button',
                                        title: 'PayPal - The safer, easier way to pay online!',
                                    }
                                }).render('#donate-button');
                            </script>
                        </div>

                    </div>
                </div>
            </div>
        </div>

    </div>
</x-app-layout>

resources/views/weather-table.blade.php
@php
    function toC($k){return $k -273.15; }
    function getDir($th){
        if($th >= 0 && $th <90)
            return "East";
        if($th >= 90 && $th < 180)
            return "North";
        if($th >= 180 && $th <270)
            return "West";
        if($th >= 270 && $th <360)
            return "South";

        return null;
    }

    function display_arrow($column){
        $sorted_column = request()->input('sort_by');
        $sorted_order = request()->input('sort_order');

        $params = "sort_by=${column}&sort_order=" . ($sorted_order == "asc" ? "desc": "asc");

        if($column == $sorted_column){
            if($sorted_order == "asc")
                return '<a href= "'. '/weather-table?' . $params   .'">
                <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-arrow-down" viewBox="0 0 16 16">
                    <path fill-rule="evenodd" d="M8 1a.5.5 0 0 1 .5.5v11.793l3.146-3.147a.5.5 0 0 1 .708.708l-4 4a.5.5 0 0 1-.708 0l-4-4a.5.5 0 0 1 .708-.708L7.5 13.293V1.5A.5.5 0 0 1 8 1z"/>
                </svg>
             </a>' ;

            else
                return '<a href= "'. '/weather-table?' . $params   .'">
                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-arrow-up" viewBox="0 0 16 16">
                      <path fill-rule="evenodd" d="M8 15a.5.5 0 0 0 .5-.5V2.707l3.146 3.147a.5.5 0 0 0 .708-.708l-4-4a.5.5 0 0 0-.708 0l-4 4a.5.5 0 1 0 .708.708L7.5 2.707V14.5a.5.5 0 0 0 .5.5z"/>
                    </svg>
             </a>' ;
        }
        else{
                return '<a href= "'. '/weather-table?' . $params   .'">
                  <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-arrow-down-up" viewBox="0 0 16 16">
                    <path fill-rule="evenodd" d="M11.5 15a.5.5 0 0 0 .5-.5V2.707l3.146 3.147a.5.5 0 0 0 .708-.708l-4-4a.5.5 0 0 0-.708 0l-4 4a.5.5 0 1 0 .708.708L11 2.707V14.5a.5.5 0 0 0 .5.5zm-7-14a.5.5 0 0 1 .5.5v11.793l3.146-3.147a.5.5 0 0 1 .708.708l-4 4a.5.5 0 0 1-.708 0l-4-4a.5.5 0 0 1 .708-.708L4 13.293V1.5a.5.5 0 0 1 .5-.5z"/>
                </svg>
             </span>' ;
        }
    }

@endphp
    <!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0,maximum-scale=1">

    <title>HS Assigment</title>

    <!-- Loading third party fonts -->
    <link href="http://fonts.googleapis.com/css?family=Roboto:300,400,700|" rel="stylesheet" type="text/css">
    <link href="fonts/font-awesome.min.css" rel="stylesheet" type="text/css">

    <!-- Loading main css file -->
    <link rel="stylesheet" href="style.css">

    <!--[if lt IE 9]>
    <script src="js/ie-support/html5.js"></script>
    <script src="js/ie-support/respond.js"></script>
    <![endif]-->

</head>
<body>


<div class="site-content">
    <div class="site-header">
        <div class="container">
            <a href="/" class="branding">
                <img src="images/logo.png" alt="" class="logo">
                <div class="logo-type">
                    <h1 class="site-title">HS Assigment</h1>
                </div>
            </a>

            <!-- Default snippet for navigation -->
            <div class="main-navigation">
                <button type="button" class="menu-toggle"><i class="fa fa-bars"></i></button>
                <ul class="menu">
                    <li class="menu-item current-menu-item"><a href="/">Home</a></li>
                    <li class="menu-item"><a href="/weather-table">Weather Table </a></li>

                </ul> <!-- .menu -->
            </div> <!-- .main-navigation -->

            <div class="mobile-navigation">
                <ul class="menu">
                    <li class="menu-item current-menu-item"><a href="index.html">Home</a></li>
                    <li class="menu-item"><a href="/weather-table">Weather Table</a></li>
                </ul>
            </div>

        </div>
    </div>

    <div class="hero" data-bg-image="images/banner.png" style="padding-bottom: 20px;     min-height: 160px;">
        <div class="container">
            <form action="weather-table" class="find-location">
                @csrf()
                <input name="q" type="text" placeholder="Find your location..." value="{{old('q', $q ?? "Spain")}}">
                <input type="submit" value="Find">
            </form>

        </div>
    </div>
    <div class="forecast-table">
        <div class="container">
            <div class="table">
                <div class="table-header">
                    <div class="header__item"><a id="name" class="filter__link" href="#">Day {!! display_arrow('day') !!}</a></div>
                    <div class="header__item"><a id="wins" class="filter__link filter__link--number" href="#">Day {!! display_arrow('temperature-day') !!}</a></div>
                    <div class="header__item"><a id="wins" class="filter__link filter__link--number" href="#">Night {!! display_arrow('temperature-night') !!}</a></div>
                    <div class="header__item"><a id="wins" class="filter__link filter__link--number" href="#">Clouds {!! display_arrow('clouds') !!}</a></div>
                    <div class="header__item"><a id="wins" class="filter__link filter__link--number" href="#">Rain {!! display_arrow('rain') !!}</a></div>
                </div>
                <div class="table-content">
                    @foreach($daily as $day)
                        <div class="table-row">
                            <div class="table-data">{{date('D d-m-Y', $day->dt)}}</div>
                            <div class="table-data">{{round(toC($day->temp->day), 1)}} <sup>o</sup>C</div>
                            <div class="table-data">{{round(toC($day->temp->night), 1)}} <sup>o</sup>C</div>
                            <div class="table-data">{{@$day->clouds ?? "-"}} </div>
                            <div class="table-data">{{isset($day->rain) ? ($day->rain * 100 . "%")  : "-"}} </div>
                        </div>
                    @endforeach
                </div>
            </div>
        </div>
    </div>

    <footer class="site-footer">
        <div class="container">
            <div class="row">
                <div class="col-md-8">
                    <form action="#" method="post" class="subscribe-form">
                        <input type="text" placeholder="" style="visibility: hidden">
                    </form>
                </div>
                <div class="col-md-3 col-md-offset-1">
                </div>
            </div>

            <p class="colophon">Copyright 2021 Harbour.Space. Designed by Adel in 60 min, All rights reserved</p>
        </div>
    </footer> <!-- .site-footer -->
</div>
<script src="js/jquery-1.11.1.min.js"></script>
<script src="js/plugins.js"></script>
<script src="js/app.js"></script>

</body>
</html>

resources/views/weather.blade.php
@php
    function toC($k){return $k -273.15; }
    function getDir($th){
        if($th >= 0 && $th <90)
            return "East";
        if($th >= 90 && $th < 180)
            return "North";
        if($th >= 180 && $th <270)
            return "West";
        if($th >= 270 && $th <360)
            return "South";

        return null;
    }
@endphp
    <!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0,maximum-scale=1">

    <title>HS Assigment</title>

    <!-- Loading third party fonts -->
    <link href="http://fonts.googleapis.com/css?family=Roboto:300,400,700|" rel="stylesheet" type="text/css">
    <link href="fonts/font-awesome.min.css" rel="stylesheet" type="text/css">

    <!-- Loading main css file -->
    <link rel="stylesheet" href="style.css">

    <!--[if lt IE 9]>
    <script src="js/ie-support/html5.js"></script>
    <script src="js/ie-support/respond.js"></script>
    <![endif]-->

</head>

<body>

<div class="site-content">
    <div class="site-header">
        <div class="container">
            <a href="/" class="branding">
                <img src="images/logo.png" alt="" class="logo">
                <div class="logo-type">
                    <h1 class="site-title">HS Assigment</h1>
                </div>
            </a>

            <!-- Default snippet for navigation -->
            <div class="main-navigation">
                <button type="button" class="menu-toggle"><i class="fa fa-bars"></i></button>
                <ul class="menu">
                    <li class="menu-item current-menu-item"><a href="/">Home</a></li>
                    <li class="menu-item"><a href="/weather-table">Weather Table </a></li>

                </ul> <!-- .menu -->
            </div> <!-- .main-navigation -->

            <div class="mobile-navigation"><ul class="menu">
                    <li class="menu-item current-menu-item"><a href="index.html">Home</a></li>
                    <li class="menu-item"><a href="/weather-table">Weather Table</a></li>
                </ul>
            </div>

        </div>
    </div>

    <div class="hero" data-bg-image="images/banner.png">
        <div class="container">
            <form action="weather" class="find-location">
                @csrf()
                <input name="q" type="text" placeholder="Find your location..." value="{{old('q', $q ?? "Spain")}}">
                <input type="submit" value="Find">
            </form>

        </div>
    </div>
    <div class="forecast-table">
        <div class="container">
            <div class="forecast-container">
                <div class="today forecast">
                    <div class="forecast-header">
                        <div class="day">{{ date('l')}}</div>
                        <div class="date">{{ date('d M')}}</div>
                    </div> <!-- .forecast-header -->
                    <div class="forecast-content">
                        <div class="location">{{$data->name}}</div>
                        <div class="degree">
                            <div class="num">{{round(toC($data->main->temp), 1)}}<sup>o</sup>C</div>
                            <div class="forecast-icon" style="margin-bottom:66px;">
                                <img src="http://openweathermap.org/img/wn/{{$data->weather[0]->icon}}.png" alt="" width=90>
                            </div>
                        </div>
                        @if(isset($data->wind) && isset($data->wind->gust))
                            <span><img src="images/icon-umberella.png" alt="">{{round($data->wind->gust, 2)}}%</span>
                        @endif
                        @if(isset($data->wind) && isset($data->wind->speed))
                            <span><img src="images/icon-wind.png" alt="">{{round($data->wind->speed, 2)}}km/h</span>
                        @endif
                        @if(isset($data->wind) && isset($data->wind->deg))
                            <span><img src="images/icon-compass.png" alt="">{{getDir($data->wind->deg)}}</span>
                        @endif
                    </div>
                </div>
                @foreach($daily as $day)
                    @if(!$loop->last && !$loop->first)
                        <div class="forecast">
                            <div class="forecast-header">
                                <div class="day">{{date('D', $day->dt)}}</div>
                            </div> <!-- .forecast-header -->
                            <div class="forecast-content">
                                <div class="forecast-icon">
                                    <img src="http://openweathermap.org/img/wn/{{$day->weather[0]->icon}}.png" alt="" width=48>
                                </div>
                                <div class="degree">{{round(toC($day->temp->day), 1)}}<sup>o</sup>C</div>
                                <small>{{round(toC($day->temp->night), 1)}}<sup>o</sup></small>
                            </div>
                        </div>
                    @endif
                @endforeach
            </div>
        </div>
    </div>

    <footer class="site-footer">
        <div class="container">
            <div class="row">
                <div class="col-md-8">
                    <form action="#" method="post" class="subscribe-form">
                        <input type="text" placeholder="" style="visibility: hidden">
                    </form>
                </div>
                <div class="col-md-3 col-md-offset-1">
                </div>
            </div>

            <p class="colophon">Copyright 2021 Harbour.Space. Designed by Adel in 60 min, All rights reserved</p>
        </div>
    </footer> <!-- .site-footer -->
</div>

<script src="js/jquery-1.11.1.min.js"></script>
<script src="js/plugins.js"></script>
<script src="js/app.js"></script>

</body>

</html>